﻿#include "CClientConnection.h"

////////////////////////////////////////////////////////////////////////////////
// コンストラクタ
////////////////////////////////////////////////////////////////////////////////
CClientConnection::CClientConnection()
{
	m_isLogin = false;
}

////////////////////////////////////////////////////////////////////////////////
// デストラクタ
////////////////////////////////////////////////////////////////////////////////
CClientConnection::~CClientConnection()
{
}

////////////////////////////////////////////////////////////////////////////////
// initialize
////////////////////////////////////////////////////////////////////////////////
bool CClientConnection::initialize()
{
	CSocket::initialize();
	return true;
}

////////////////////////////////////////////////////////////////////////////////
// send
////////////////////////////////////////////////////////////////////////////////
bool CClientConnection::send(const CommunicationData* in_pCommunicationData)
{
	// サイズは決め打ち
	if(::send(m_Socket, reinterpret_cast<const char*>(in_pCommunicationData), MAX_COMMUNICATION_DATA_LENGTH, 0) == SOCKET_ERROR){
		return false;
	}
	return true;
}

////////////////////////////////////////////////////////////////////////////////
// receive
////////////////////////////////////////////////////////////////////////////////
bool CClientConnection::receive(CommunicationData** out_ppCommunicationData)
{
	if(m_Buffer.empty()){
		return false;
	}

	*out_ppCommunicationData = reinterpret_cast<CommunicationData*>(m_Buffer.getReadPointer()->m_Buffer);
	m_Buffer.nextReadBuffer();
	return true;
}

////////////////////////////////////////////////////////////////////////////////
// login
////////////////////////////////////////////////////////////////////////////////
bool CClientConnection::login(const char* in_pLoginName)
{
	CommunicationData a_SendData;
	a_SendData.m_DataType = 'i';
	strcpy(a_SendData.m_Data.m_LoginData.m_Name, in_pLoginName);
	send(&a_SendData);

	// このフラグは受信メッセージを確かめてから変更するべき
	m_isLogin = true;
	return true;
}

////////////////////////////////////////////////////////////////////////////////
// logout
////////////////////////////////////////////////////////////////////////////////
bool CClientConnection::logout()
{
	CommunicationData a_SendData;
	a_SendData.m_DataType = 'o';
	send(&a_SendData);
	return true;
}

////////////////////////////////////////////////////////////////////////////////
// 座標取得
////////////////////////////////////////////////////////////////////////////////
bool CClientConnection::requestPosition()
{
	CommunicationData a_SendData;
	a_SendData.m_DataType = 'p';
	send(&a_SendData);
	return true;
}

////////////////////////////////////////////////////////////////////////////////
// 移動
////////////////////////////////////////////////////////////////////////////////
bool CClientConnection::requestMove(char in_Direction)
{
	CommunicationData a_SendData;
	a_SendData.m_DataType = 'a';
	a_SendData.m_Data.m_ActionCommand.m_CommandType = in_Direction;
	send(&a_SendData);
	return true;
}

////////////////////////////////////////////////////////////////////////////////
// 音声送信
////////////////////////////////////////////////////////////////////////////////
bool CClientConnection::sendVoice(char* in_pVoice, int in_Length, bool in_isEnd)
{
	CommunicationData a_SendData;

	if(sizeof(a_SendData.m_Data.m_Voice.m_Stream) < in_Length){
		return false;
	}

	a_SendData.m_DataType = 'v';
	for(int i = 0; i < in_Length; i++){
		a_SendData.m_Data.m_Voice.m_Stream[i] = in_pVoice[i];
	}
	a_SendData.m_Data.m_Voice.m_Length = in_Length;
	a_SendData.m_Data.m_Voice.m_isEnd = in_isEnd;
	send(&a_SendData);
	return true;
}
