﻿#ifndef INC_CClientConnection
#define INC_CClientConnection

// インクルードは必ず必要な物だけ
// 内部で利用するだけの物はソースに記述
#include "Environment.h"
#include "CSocket.h"
#include "Data.h"

// 関数名はローワキャメルケースとする

////////////////////////////////////////////////////////////////////////////////
// CClientConnection
// 通信用クラス
// internetcity用の通信用
// コマンドならTCP、音声ならUDPを使用する
// 構文解析の機能を実現する
// 処理にかかわる内容は記述しない
////////////////////////////////////////////////////////////////////////////////
class CClientConnection : public CSocket
{
	////////////////////////////////////////////////////////////////////////////////
	// メンバ変数
	////////////////////////////////////////////////////////////////////////////////
private:
	// あとで消す
	bool m_isLogin;

	////////////////////////////////////////////////////////////////////////////////
	// コンストラクタ
	////////////////////////////////////////////////////////////////////////////////
public:
	CClientConnection();

	////////////////////////////////////////////////////////////////////////////////
	// デストラクタ
	////////////////////////////////////////////////////////////////////////////////
public:
	~CClientConnection();

	////////////////////////////////////////////////////////////////////////////////
	// static関数、コールバック関数
	////////////////////////////////////////////////////////////////////////////////
	////////////////////////////////////////////////////////////////////////////////
	// 操作メソッド
	////////////////////////////////////////////////////////////////////////////////
public:
	// initialize
	bool initialize();

	// send関連
protected:
	// send
	bool send(const CommunicationData* in_pCommunicationData);
public:
	// login
	bool login(const char* in_pLoginName);
	// logout
	bool logout();
	// 座標取得
	bool requestPosition();
	// 移動
	bool requestMove(char in_Direction);
	// 音声送信
	bool sendVoice(char* in_pVoice, int in_Length, bool in_isEnd);

	// receive関連
public:
	// receive
	bool receive(CommunicationData** out_ppCommunicationData);

	////////////////////////////////////////////////////////////////////////////////
	// 属性メソッド
	////////////////////////////////////////////////////////////////////////////////
	////////////////////////////////////////////////////////////////////////////////
	// イテレーション
	////////////////////////////////////////////////////////////////////////////////
	////////////////////////////////////////////////////////////////////////////////
	// 状態
	////////////////////////////////////////////////////////////////////////////////

	////////////////////////////////////////////////////////////////////////////////
	// 演算子
	////////////////////////////////////////////////////////////////////////////////
	////////////////////////////////////////////////////////////////////////////////
	// 純粋仮想関数、定義のみ（非実装提供）
	////////////////////////////////////////////////////////////////////////////////
	////////////////////////////////////////////////////////////////////////////////
	// 内部クラス
	////////////////////////////////////////////////////////////////////////////////


};

#endif //INC_CClientConnection
