﻿// 京
#ifndef INC_COutputWave
#define INC_COutputWave

// インクルードは必ず必要な物だけ
// 内部で利用するだけの物はソースに記述

// 関数名はローワキャメルケースとする


#include "CWaveData.h"
#include "CRingBuffer.h"

#include <list>

////////////////////////////////////////////////////////////////////////////////
// COutputWave
////////////////////////////////////////////////////////////////////////////////
class COutputWave
{
	////////////////////////////////////////////////////////////////////////////////
	// メンバ変数
	////////////////////////////////////////////////////////////////////////////////
private:
	// wave format
	WAVEFORMATEX m_WaveFormat;
	// Waveデバイスハンドル
	HWAVEOUT m_hWaveOut;
	// Waveヘッダー
	typedef CRingBuffer<WAVEHDR> WaveHeaderTable;
	WaveHeaderTable m_WaveHeaders;
	// Waveバッファ
	//typedef CRingBuffer<StructWaveBuffer> WaveBufferTable;
	CWaveData m_WaveBuffers;
	//char* m_pFinishWaveBuffer;


	// デバイスをオープンしている
	bool m_isOpen;
	// 再生中
	bool m_isOutput;

	////////////////////////////////////////////////////////////////////////////////
	// コンストラクタ
	////////////////////////////////////////////////////////////////////////////////
public:
	COutputWave();

	////////////////////////////////////////////////////////////////////////////////
	// デストラクタ
	////////////////////////////////////////////////////////////////////////////////
public:
	virtual ~COutputWave();

	////////////////////////////////////////////////////////////////////////////////
	// static関数、コールバック関数
	////////////////////////////////////////////////////////////////////////////////
	// 出力デバイスの状態を知らせるコールバック関数
	static void CALLBACK waveOutProc(HWAVEOUT in_hWaveOut, UINT in_Message, DWORD in_Instance, DWORD in_Param1, DWORD in_Param2);
	void callbackWave(HWAVEOUT in_hWaveOut, UINT in_Message, DWORD in_Instance, DWORD in_Param1, DWORD in_Param2);


	////////////////////////////////////////////////////////////////////////////////
	// 操作メソッド
	////////////////////////////////////////////////////////////////////////////////
public:
	// 初期化
	void initialize();
	// デバイスを開く
	bool open();
	// デバイスを閉じる
	bool close();
protected:
	// add wave buffer in queue
	bool addWaveBuffer();
public:
	// 出力（再生）を開始する
	bool start();
	// 出力（再生）を停止する
	bool stop();
	// 音声データをセットする
	bool setWaveDataPointer(const StructWaveBuffer* in_pWaveBuffer);

	////////////////////////////////////////////////////////////////////////////////
	// 属性メソッド
	////////////////////////////////////////////////////////////////////////////////
public:

	////////////////////////////////////////////////////////////////////////////////
	// イテレーション
	////////////////////////////////////////////////////////////////////////////////
	////////////////////////////////////////////////////////////////////////////////
	// 状態
	////////////////////////////////////////////////////////////////////////////////

	////////////////////////////////////////////////////////////////////////////////
	// 演算子
	////////////////////////////////////////////////////////////////////////////////
	////////////////////////////////////////////////////////////////////////////////
	// 純粋仮想関数、定義のみ（非実装提供）
	////////////////////////////////////////////////////////////////////////////////
	////////////////////////////////////////////////////////////////////////////////
	// 内部クラス
	////////////////////////////////////////////////////////////////////////////////


};

#endif //INC_COutputWave
