﻿#include "CServerConnection.h"


////////////////////////////////////////////////////////////////////////////////
// コンストラクタ
////////////////////////////////////////////////////////////////////////////////
CServerConnection::CServerConnection()
{
}

////////////////////////////////////////////////////////////////////////////////
// デストラクタ
////////////////////////////////////////////////////////////////////////////////
CServerConnection::~CServerConnection()
{
}

////////////////////////////////////////////////////////////////////////////////
// initialize
////////////////////////////////////////////////////////////////////////////////
bool CServerConnection::initialize()
{
	CSocket::initialize();
	return true;
}

////////////////////////////////////////////////////////////////////////////////
// send
////////////////////////////////////////////////////////////////////////////////
bool CServerConnection::send(const CommunicationData* in_pCommunicationData)
{
	// サイズは決め打ち
	if(::send(m_Socket, reinterpret_cast<const char*>(in_pCommunicationData), MAX_COMMUNICATION_DATA_LENGTH, 0) == SOCKET_ERROR){
		return false;
	}
	return true;
}

////////////////////////////////////////////////////////////////////////////////
// receive
////////////////////////////////////////////////////////////////////////////////
bool CServerConnection::receive(CommunicationData** out_ppCommunicationData)
{
	if(m_Buffer.empty()){
		return false;
	}

	*out_ppCommunicationData = reinterpret_cast<CommunicationData*>(m_Buffer.getReadPointer()->m_Buffer);
	m_Buffer.nextReadBuffer();
	return true;
}

////////////////////////////////////////////////////////////////////////////////
// 送信関数 ログイン
////////////////////////////////////////////////////////////////////////////////
bool CServerConnection::sendLogin()
{
	return true;
}

////////////////////////////////////////////////////////////////////////////////
// 送信関数 ログアウト
////////////////////////////////////////////////////////////////////////////////
bool CServerConnection::sendLogout()
{
	return true;
}

////////////////////////////////////////////////////////////////////////////////
// 送信関数 一般コマンド
////////////////////////////////////////////////////////////////////////////////
bool CServerConnection::sendGeneralCommand(char kind)
{
	return true;
}

////////////////////////////////////////////////////////////////////////////////
// 送信関数 アクションコマンド
////////////////////////////////////////////////////////////////////////////////
bool CServerConnection::sendActionCommand(char kind)
{
	return true;
}

////////////////////////////////////////////////////////////////////////////////
// 送信関数 音声
////////////////////////////////////////////////////////////////////////////////
bool CServerConnection::sendVoice(char* in_pVoice, int in_Length, bool in_isEnd)
{
	CommunicationData a_SendData;

	if(sizeof(a_SendData.m_Data.m_Voice.m_Stream) < in_Length){
		return false;
	}

	a_SendData.m_DataType = 'v';
	for(int i = 0; i < in_Length; i++){
		a_SendData.m_Data.m_Voice.m_Stream[i] = in_pVoice[i];
	}
	a_SendData.m_Data.m_Voice.m_Length = in_Length;
	a_SendData.m_Data.m_Voice.m_isEnd = in_isEnd;
	send(&a_SendData);
	return true;
}
