﻿#ifndef INC_CServerConnection
#define INC_CServerConnection

// インクルードは必ず必要な物だけ
// 内部で利用するだけの物はソースに記述
#include "CSocket.h"
#include "Data.h"

// 関数名はローワキャメルケースとする

////////////////////////////////////////////////////////////////////////////////
// CServerConnection
// 通信用クラス
// internetcity用の通信用
// コマンドならTCP、音声ならUDPを使用する
// 構文解析の機能を実現する
// 処理にかかわる内容は記述しない
// 変数ではなく関数結合にする
////////////////////////////////////////////////////////////////////////////////
class CServerConnection : public CSocket
{
	////////////////////////////////////////////////////////////////////////////////
	// メンバ変数
	////////////////////////////////////////////////////////////////////////////////
private:
	////////////////////////////////////////////////////////////////////////////////
	// コンストラクタ
	////////////////////////////////////////////////////////////////////////////////
public:
	CServerConnection();

	////////////////////////////////////////////////////////////////////////////////
	// デストラクタ
	////////////////////////////////////////////////////////////////////////////////
public:
	~CServerConnection();

	////////////////////////////////////////////////////////////////////////////////
	// static関数、コールバック関数
	////////////////////////////////////////////////////////////////////////////////
	////////////////////////////////////////////////////////////////////////////////
	// 操作メソッド
	////////////////////////////////////////////////////////////////////////////////
public:
	// initialize
	bool initialize();
public:
	// send
	bool send(const CommunicationData* in_pCommunicationData);
public:
	// receive
	bool receive(CommunicationData** out_ppCommunicationData);

public:
	// 送信関数
	// ログイン
	bool sendLogin();
	// ログアウト
	bool sendLogout();
	// 一般コマンド
	bool sendGeneralCommand(char kind);
	// アクションコマンド
	bool sendActionCommand(char kind);
	// 音声
	bool sendVoice(char* in_pVoice, int in_Length, bool in_isEnd);

	////////////////////////////////////////////////////////////////////////////////
	// 属性メソッド
	////////////////////////////////////////////////////////////////////////////////
public:
	////////////////////////////////////////////////////////////////////////////////
	// イテレーション
	////////////////////////////////////////////////////////////////////////////////
	////////////////////////////////////////////////////////////////////////////////
	// 状態
	////////////////////////////////////////////////////////////////////////////////

	////////////////////////////////////////////////////////////////////////////////
	// 演算子
	////////////////////////////////////////////////////////////////////////////////
	////////////////////////////////////////////////////////////////////////////////
	// 純粋仮想関数、定義のみ（非実装提供）
	////////////////////////////////////////////////////////////////////////////////
	////////////////////////////////////////////////////////////////////////////////
	// 内部クラス
	////////////////////////////////////////////////////////////////////////////////


};

#endif //INC_CServerConnection
