﻿#ifndef INC_CServerSocket
#define INC_CServerSocket

// インクルードは必ず必要な物だけ
// 内部で利用するだけの物はソースに記述
// winsock2.hはwindows.hより先にインクルードしなければならないらしい
//#include <winsock2.h>
#include "CThread.h"
#include "CSocket.h"

#include <list>

// 関数名はローワキャメルケースとする

////////////////////////////////////////////////////////////////////////////////
// CServerSocket
////////////////////////////////////////////////////////////////////////////////
class CServerSocket : public CThread
{
	////////////////////////////////////////////////////////////////////////////////
	// メンバ変数
	////////////////////////////////////////////////////////////////////////////////
private:
	WSADATA m_WsaData;
	// 自分自身のソケット
	SOCKET m_ServerSocket;
	sockaddr_in m_ServerSocketAddress;

	std::list<CSocket*> m_NonConnectedSockets;
	std::list<CSocket*> m_ConnectedSockets;

	// ポート番号
	unsigned short m_PortNumber;

	////////////////////////////////////////////////////////////////////////////////
	// コンストラクタ
	////////////////////////////////////////////////////////////////////////////////
public:
	CServerSocket();

	////////////////////////////////////////////////////////////////////////////////
	// デストラクタ
	////////////////////////////////////////////////////////////////////////////////
public:
	~CServerSocket();

	////////////////////////////////////////////////////////////////////////////////
	// static関数、コールバック関数
	////////////////////////////////////////////////////////////////////////////////
	////////////////////////////////////////////////////////////////////////////////
	// 操作メソッド
	////////////////////////////////////////////////////////////////////////////////
public:
	// 初期化
	bool initialize();
	// 非初期化
	bool uninitialize();
	// open port
	bool openPort();
	// close port
	bool closePort();
	// accept
	bool accept(CSocket* io_pSocket);

protected:
	// スレッドループ
	void run();


	////////////////////////////////////////////////////////////////////////////////
	// 属性メソッド
	////////////////////////////////////////////////////////////////////////////////
public:
	// 接続許可したクライアントを取得する
	//CSocket* getAcceptSocket();
	unsigned short getPortNumber() { return m_PortNumber; }

	////////////////////////////////////////////////////////////////////////////////
	// イテレーション
	////////////////////////////////////////////////////////////////////////////////
	////////////////////////////////////////////////////////////////////////////////
	// 状態
	////////////////////////////////////////////////////////////////////////////////

	////////////////////////////////////////////////////////////////////////////////
	// 演算子
	////////////////////////////////////////////////////////////////////////////////
	////////////////////////////////////////////////////////////////////////////////
	// 純粋仮想関数、定義のみ（非実装提供）
	////////////////////////////////////////////////////////////////////////////////
	////////////////////////////////////////////////////////////////////////////////
	// 内部クラス
	////////////////////////////////////////////////////////////////////////////////


};

#endif //INC_CServerSocket
