﻿// 京
#ifndef INC_CWaveData
#define INC_CWaveData


#include "CRingBuffer.h"
#include <Windows.h>


// インクルードは必ず必要な物だけ
// 内部で利用するだけの物はソースに記述

// 関数名はローワキャメルケースとする


// wave buffer struct
struct StructWaveBuffer
{
	// バッファへのポインタ
	char* m_pWaveBuffer;
	// 録音時間 [ミリ秒]
	DWORD m_RecorMilliSecond;
	// バッファサイズ [byte]
	DWORD m_BufferSize;
};


////////////////////////////////////////////////////////////////////////////////
// CWaveData
// Waveデータを扱うクラス
// バッファの管理（確保と解放）を行う
// キューを用いてバッファ管理を行う
////////////////////////////////////////////////////////////////////////////////
class CWaveData : public CRingBuffer<StructWaveBuffer>
{
	////////////////////////////////////////////////////////////////////////////////
	// メンバ変数
	////////////////////////////////////////////////////////////////////////////////
private:
	////////////////////////////////////////////////////////////////////////////////
	// コンストラクタ
	////////////////////////////////////////////////////////////////////////////////
public:
	CWaveData(){}

	////////////////////////////////////////////////////////////////////////////////
	// デストラクタ
	////////////////////////////////////////////////////////////////////////////////
public:
	~CWaveData(){}

	////////////////////////////////////////////////////////////////////////////////
	// static関数、コールバック関数
	////////////////////////////////////////////////////////////////////////////////
	////////////////////////////////////////////////////////////////////////////////
	// 操作メソッド
	////////////////////////////////////////////////////////////////////////////////
public:
	// バッファを確保
	bool allocate(int in_BufferNumber, DWORD in_RecorMilliSecond, DWORD in_BufferSize)
	{
		if(!CRingBuffer::allocate(in_BufferNumber) || in_BufferSize == 0){
			return false;
		}

		for(int i = 0; i < in_BufferNumber; i++){
			StructWaveBuffer tempWaveBuffer;
			tempWaveBuffer.m_RecorMilliSecond = in_RecorMilliSecond;
			tempWaveBuffer.m_BufferSize       = in_BufferSize;
			tempWaveBuffer.m_pWaveBuffer      = new char[tempWaveBuffer.m_BufferSize];
			*at(i) = tempWaveBuffer;
		}

		return true;
	}

	void clear()
	{
		for(size_t i = 0; i < size(); i++){
			StructWaveBuffer* tempWaveBuffer = at(i);
			delete tempWaveBuffer->m_pWaveBuffer;
		}
		CRingBuffer::clear();
	}

	////////////////////////////////////////////////////////////////////////////////
	// 属性メソッド
	////////////////////////////////////////////////////////////////////////////////
	////////////////////////////////////////////////////////////////////////////////
	// イテレーション
	////////////////////////////////////////////////////////////////////////////////
	////////////////////////////////////////////////////////////////////////////////
	// 状態
	////////////////////////////////////////////////////////////////////////////////
	////////////////////////////////////////////////////////////////////////////////
	// 演算子
	////////////////////////////////////////////////////////////////////////////////
	////////////////////////////////////////////////////////////////////////////////
	// 純粋仮想関数、定義のみ（非実装提供）
	////////////////////////////////////////////////////////////////////////////////
	////////////////////////////////////////////////////////////////////////////////
	// 内部クラス
	////////////////////////////////////////////////////////////////////////////////


};


#endif //INC_CWaveData
