﻿// 京

#ifndef INC_DATA
#define INC_DATA

static const int MAX_AVATAR_NAME_LENGTH = 32;
static const int MAX_COMMUNICATION_DATA_LENGTH = 120;

#include "CWaveData.h"

// アバターの情報
struct AvatarInformation
{
	// キャラクター名
	char m_Name[MAX_AVATAR_NAME_LENGTH];
	// 座標
	double m_Position[3];
	// 方向
	double m_Direction[3];
	// サイズ
	double m_Radias;
	// 音声データ
	CWaveData m_Voice;
	// 圧縮音声データ
	char m_Stream[3000];
	int m_Length;
};

struct VoiceData{
	char m_Stream[100];
	short m_Length;
	char m_isEnd;
};

// 一般通信データ
struct CommunicationData{
	// データの種類
	char m_DataType;
	// データ
	union{
		struct{
			char m_Name[MAX_AVATAR_NAME_LENGTH];
		} m_LoginData;
		struct{
			// 有効かどうか
			char m_Enable;
			// 名前
			char m_Name[MAX_AVATAR_NAME_LENGTH];
			// 座標
			double m_Position[3];
			// 方向
			double m_Direction[3];
			// サイズ
			double m_Radias;
		} m_AvatarData;
		struct{
			char m_CommandType;
		} m_ActionCommand;
		// 音声
		VoiceData m_Voice;
		// データサイズ調整
		char m_Dummy[MAX_COMMUNICATION_DATA_LENGTH - 1];
	} m_Data;
};

#endif // INC_DATA
