﻿#ifndef INC_CClient
#define INC_CClient

// インクルードは必ず必要な物だけ
// 内部で利用するだけの物はソースに記述
#include "CClientModel.h"
#include "CClientUI.h"

// 関数名はローワキャメルケースとする

////////////////////////////////////////////////////////////////////////////////
// CClient
////////////////////////////////////////////////////////////////////////////////
class CClient
{
	////////////////////////////////////////////////////////////////////////////////
	// メンバ変数
	////////////////////////////////////////////////////////////////////////////////
private:
	CClientUI m_UI;
	CClientModel m_Model;

	////////////////////////////////////////////////////////////////////////////////
	// コンストラクタ
	////////////////////////////////////////////////////////////////////////////////
public:
	CClient();

	////////////////////////////////////////////////////////////////////////////////
	// デストラクタ
	////////////////////////////////////////////////////////////////////////////////
public:
	~CClient();

	////////////////////////////////////////////////////////////////////////////////
	// static関数、コールバック関数
	////////////////////////////////////////////////////////////////////////////////
	////////////////////////////////////////////////////////////////////////////////
	// 操作メソッド
	////////////////////////////////////////////////////////////////////////////////
public:
	// 初期化
	bool initialize();
	// main loop
	void mainloop();


	////////////////////////////////////////////////////////////////////////////////
	// 属性メソッド
	////////////////////////////////////////////////////////////////////////////////
public:
	// 起動パラメータを入力する
	void setArgement(int* in_pArgc, char** in_ppArgv)
	{
		m_UI.setArgement(in_pArgc, in_ppArgv);
	}

public:
	// ログイン名を入力する
	void setLoginName(std::string in_LoginName)
	{
		m_Model.setLoginName(in_LoginName);
	}

	void setServerAddress(const char* in_pIpAddress, unsigned short in_PortNumber)
	{
		m_Model.setServerAddress(in_pIpAddress, in_PortNumber);
	}

	////////////////////////////////////////////////////////////////////////////////
	// イテレーション
	////////////////////////////////////////////////////////////////////////////////
	////////////////////////////////////////////////////////////////////////////////
	// 状態
	////////////////////////////////////////////////////////////////////////////////

	////////////////////////////////////////////////////////////////////////////////
	// 演算子
	////////////////////////////////////////////////////////////////////////////////
	////////////////////////////////////////////////////////////////////////////////
	// 純粋仮想関数、定義のみ（非実装提供）
	////////////////////////////////////////////////////////////////////////////////
	////////////////////////////////////////////////////////////////////////////////
	// 内部クラス
	////////////////////////////////////////////////////////////////////////////////


};

#endif //INC_CClient
