﻿#ifndef INC_CClientUI
#define INC_CClientUI

// インクルードは必ず必要な物だけ
// 内部で利用するだけの物はソースに記述
#include "../../common/CThread.h"
#include "CClientModel.h"
#include <list>
#include <string>

typedef std::string ClientInputEvent;

// 関数名はローワキャメルケースとする

////////////////////////////////////////////////////////////////////////////////
// CClientUI
////////////////////////////////////////////////////////////////////////////////
class CClientUI : public CThread
{
	////////////////////////////////////////////////////////////////////////////////
	// メンバ変数
	////////////////////////////////////////////////////////////////////////////////
private:
	static CClientUI* sm_pUI;
	std::list<ClientInputEvent> m_Events;
	bool m_isEnd;
	int* m_pArgc;
	char** m_ppArgv;

	CClientModel* m_pModel;

	CriticalSectionID m_CriticalSectionOfEvent;

	////////////////////////////////////////////////////////////////////////////////
	// コンストラクタ
	////////////////////////////////////////////////////////////////////////////////
public:
	CClientUI();

	////////////////////////////////////////////////////////////////////////////////
	// デストラクタ
	////////////////////////////////////////////////////////////////////////////////
public:
	~CClientUI();

	////////////////////////////////////////////////////////////////////////////////
	// static関数、コールバック関数
	////////////////////////////////////////////////////////////////////////////////
	static void display();
	void init();
	static void keyboard(unsigned char in_Key, int in_x, int in_y);
	static void downSpecialKey(int in_Key, int in_x, int in_y);
	static void upSpecialKey(int in_Key, int in_x, int in_y);
	static void timer(int value);
	static void reshape(int w, int h);

	////////////////////////////////////////////////////////////////////////////////
	// 操作メソッド
	////////////////////////////////////////////////////////////////////////////////
public:
	// start input
	bool initialize();
	// stop input
	bool uninitialize();
	// thread loop
	void run();

	////////////////////////////////////////////////////////////////////////////////
	// 属性メソッド
	////////////////////////////////////////////////////////////////////////////////
public:
	void setArgement(int* in_pArgc, char** in_ppArgv)
	{
		m_pArgc = in_pArgc;
		m_ppArgv = in_ppArgv;
	}

	ClientInputEvent getEvent()
	{
		enterCriticalSectionID(m_CriticalSectionOfEvent);
		ClientInputEvent temp = m_Events.front();
		m_Events.pop_front();
		leaveCriticalSectionID(m_CriticalSectionOfEvent);
		return temp;
	}

	void setModel(CClientModel* io_pModel)
	{
		m_pModel = io_pModel;
	}

	////////////////////////////////////////////////////////////////////////////////
	// イテレーション
	////////////////////////////////////////////////////////////////////////////////
	////////////////////////////////////////////////////////////////////////////////
	// 状態
	////////////////////////////////////////////////////////////////////////////////
public:
	bool existEvent()
	{
		return !m_Events.empty();
	}

	////////////////////////////////////////////////////////////////////////////////
	// 演算子
	////////////////////////////////////////////////////////////////////////////////
	////////////////////////////////////////////////////////////////////////////////
	// 純粋仮想関数、定義のみ（非実装提供）
	////////////////////////////////////////////////////////////////////////////////
	////////////////////////////////////////////////////////////////////////////////
	// 内部クラス
	////////////////////////////////////////////////////////////////////////////////


};

#endif //INC_CClientUI
