﻿// 京

#include "../../common/Environment.h"

#ifdef WIN32
	//#pragma comment(linker, "/subsystem:\"windows\" /entry:\"mainCRTStartup\"")
#endif // WIN32

// 通信について
// 音声はRTPを使って通信を行いたいが、現在ライブラリは調査中である。
// さらに、コマンドと音声の切り分けや同期も現在検討中である。
// よって、現段階ではコマンドも音声もすべてTCPを使用して通信を行う。
// TCPを使用するため、コマンドも音声も遅延が生じると考えられる。
// さらに、音声は常に送信を行っているため、バッファがあるれるものと考えられる。
// その場合は、新しいコマンドや音声を破棄することで対応を行う。
// これを行うことによって、コマンドが反応しなかったり、音声がとぎれとぎれになるものと考えられる。
// もうひとつの方法として、音声情報をより圧縮しデータ量を削減する方法がある。
// この方法は上記の方法を試した後に行うものとする。または直接RTPを使用した方法を実装する。


// to do
// 音声の入力
// 音声の出力
// 圧縮
// 解答
// コマンドの入力
// サーバーとの通信共通処理
// サーバーへのログイン
// サーバーとのデータやり取り

#include "CClient.h"

#include <iostream>

int main(int argc, char* argv[])
{
	char a_LoginName[256];
	std::cout << "Please, input login name." << std::endl;
	std::cin >> a_LoginName;

	char a_IpAddress[20];
	std::cout << "Please, input server ip address." << std::endl;
	std::cin >> a_IpAddress;

	unsigned short a_PortNumber;
	std::cout << "Please, input server port number." << std::endl;
	std::cin >> a_PortNumber;


	CClient a_Client;
	a_Client.initialize();
	a_Client.setArgement(&argc, argv);
	a_Client.setLoginName(a_LoginName);
	a_Client.setServerAddress(a_IpAddress, a_PortNumber);
	a_Client.mainloop();

	return 0;
}
