﻿#include "CServerInput.h"

#include <iostream>

////////////////////////////////////////////////////////////////////////////////
// constructor
////////////////////////////////////////////////////////////////////////////////
CServerInput::CServerInput()
{
	m_CriticalSectionOfEvent = createCriticalSectionID();
	m_isEnd = false;
}

////////////////////////////////////////////////////////////////////////////////
// destructor
////////////////////////////////////////////////////////////////////////////////
CServerInput::~CServerInput()
{
	deleteCriticalSectionID(m_CriticalSectionOfEvent);
	uninitialize();
}

////////////////////////////////////////////////////////////////////////////////
// start input
////////////////////////////////////////////////////////////////////////////////
bool CServerInput::initialize()
{
	start();
	return true;
}

////////////////////////////////////////////////////////////////////////////////
// stop input
////////////////////////////////////////////////////////////////////////////////
bool CServerInput::uninitialize()
{
	m_isEnd = true;
	return true;
}

////////////////////////////////////////////////////////////////////////////////
// thread loop
////////////////////////////////////////////////////////////////////////////////
void CServerInput::run()
{
	while(true){
		if(m_isEnd){
			break;
		}

		std::string input;
		std::cin >> input;
		enterCriticalSectionID(m_CriticalSectionOfEvent);
		m_Events.push_back(input);
		leaveCriticalSectionID(m_CriticalSectionOfEvent);
	}
}
