﻿#ifndef INC_CServerInput
#define INC_CServerInput

// インクルードは必ず必要な物だけ
// 内部で利用するだけの物はソースに記述
#include "../../common/CThread.h"
#include <list>
#include <string>

typedef std::string ServerInputEvent;

// 関数名はローワキャメルケースとする

////////////////////////////////////////////////////////////////////////////////
// CServerInput
////////////////////////////////////////////////////////////////////////////////
class CServerInput : public CThread
{
	////////////////////////////////////////////////////////////////////////////////
	// メンバ変数
	////////////////////////////////////////////////////////////////////////////////
private:
	std::list<ServerInputEvent> m_Events;
	bool m_isEnd;

	CriticalSectionID m_CriticalSectionOfEvent;

	////////////////////////////////////////////////////////////////////////////////
	// コンストラクタ
	////////////////////////////////////////////////////////////////////////////////
public:
	CServerInput();

	////////////////////////////////////////////////////////////////////////////////
	// デストラクタ
	////////////////////////////////////////////////////////////////////////////////
public:
	~CServerInput();

	////////////////////////////////////////////////////////////////////////////////
	// static関数、コールバック関数
	////////////////////////////////////////////////////////////////////////////////
	////////////////////////////////////////////////////////////////////////////////
	// 操作メソッド
	////////////////////////////////////////////////////////////////////////////////
public:
	// start input
	bool initialize();
	// stop input
	bool uninitialize();
	// thread loop
	void run();

	////////////////////////////////////////////////////////////////////////////////
	// 属性メソッド
	////////////////////////////////////////////////////////////////////////////////
public:
	ServerInputEvent getEvent()
	{
		enterCriticalSectionID(m_CriticalSectionOfEvent);
		ServerInputEvent temp = m_Events.front();
		m_Events.pop_front();
		leaveCriticalSectionID(m_CriticalSectionOfEvent);
		return temp;
	}

	////////////////////////////////////////////////////////////////////////////////
	// イテレーション
	////////////////////////////////////////////////////////////////////////////////
	////////////////////////////////////////////////////////////////////////////////
	// 状態
	////////////////////////////////////////////////////////////////////////////////
public:
	bool existEvent()
	{
		return !m_Events.empty();
	}

	////////////////////////////////////////////////////////////////////////////////
	// 演算子
	////////////////////////////////////////////////////////////////////////////////
	////////////////////////////////////////////////////////////////////////////////
	// 純粋仮想関数、定義のみ（非実装提供）
	////////////////////////////////////////////////////////////////////////////////
	////////////////////////////////////////////////////////////////////////////////
	// 内部クラス
	////////////////////////////////////////////////////////////////////////////////


};

#endif //INC_CServerInput
